// InfoVolumeWnd.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "InfoVolumeWnd.h"

// CInfoVolumeWnd
IMPLEMENT_DYNAMIC(CInfoVolumeWnd, CWnd)

CInfoVolumeWnd::CInfoVolumeWnd()
{
	// BG
	m_pImgBG = NULL;
	m_pImgVolume_B = NULL;
	m_pImgVolumeBG_B = NULL;
	m_pImgVolume_R = NULL;
	m_pImgVolumeBG_R = NULL;

	// dimension
	m_rtWnd.SetRectEmpty();
	m_rtVolume.SetRectEmpty();

	// attribute
	m_nVolumeLimit = 0;
	m_nVolume = 0;
}

CInfoVolumeWnd::~CInfoVolumeWnd()
{
	
}

BEGIN_MESSAGE_MAP(CInfoVolumeWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

void CInfoVolumeWnd::SetImgBGPath(CString strFileName)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
	{
		strFileName = _T("Info_Volume_BG.png");
	}
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgBG = new Image(strImgPath);

	//WCHAR wszImg[MAX_PATH] = L"";
	//CCommonClass::ConvertAnsiStringToWide(wszImg, strImgPath, -1);
	//m_pImgBG = new Image(wszImg);
}

void CInfoVolumeWnd::SetImgVolumePath(CString strFileName, CString strFileNameBG)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
	{
		strFileName = _T("Info_Volume_Real_B.png");
	}
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgVolume_B = new Image(strImgPath);

	//WCHAR wszImg[MAX_PATH] = L"";
	//CCommonClass::ConvertAnsiStringToWide(wszImg, strImgPath, -1);
	//m_pImgMain = new Image(wszImg);

	if (strFileNameBG.IsEmpty())
	{
		strFileNameBG = _T("Info_Volume_Real_BG_B.png");
	}
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBG);

	m_pImgVolumeBG_B = new Image(strImgPath);

	//WCHAR wszImg[MAX_PATH] = L"";
	//CCommonClass::ConvertAnsiStringToWide(wszImg, strImgPath, -1);
	//m_pImgMain = new Image(wszImg);
}

void CInfoVolumeWnd::SetImgVolumePath_R(CString strFileName, CString strFileNameBG)
{
	CString strImgPath = _T(""), strImgDir = _T("");

	strImgDir = GetAppImgDir();

	if (strFileName.IsEmpty())
	{
		strFileName = _T("Info_Volume_Real_R.png");
	}
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileName);

	m_pImgVolume_R = new Image(strImgPath);

	//WCHAR wszImg[MAX_PATH] = L"";
	//CCommonClass::ConvertAnsiStringToWide(wszImg, strImgPath, -1);
	//m_pImgMain = new Image(wszImg);

	if (strFileNameBG.IsEmpty())
	{
		strFileNameBG = _T("Info_Volume_Real_BG_R.png");
	}
	strImgPath.Format(_T("%s\\%s"), strImgDir, strFileNameBG);

	m_pImgVolumeBG_R = new Image(strImgPath);

	//WCHAR wszImg[MAX_PATH] = L"";
	//CCommonClass::ConvertAnsiStringToWide(wszImg, strImgPath, -1);
	//m_pImgMain = new Image(wszImg);
}

void CInfoVolumeWnd::SetVolume(int nVolune)
{
	m_nVolume = nVolune;

	RedrawWindow(&m_rtVolume, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

void CInfoVolumeWnd::SetVolumeLimit(int nVolLimit)
{
	m_nVolumeLimit = nVolLimit;

	RedrawWindow(&m_rtVolume, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
}

// CInfoVolumeWnd ޽ óԴϴ.
int CInfoVolumeWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	return 0;
}

BOOL CInfoVolumeWnd::OnEraseBkgnd(CDC* pDC)
{
	return TRUE;
}

void CInfoVolumeWnd::OnPaint()
{
	CPaintDC dc(this);
	
	PAINTSTRUCT ps = dc.m_ps;
	int psWidth = ps.rcPaint.right - ps.rcPaint.left;
	int psHeight = ps.rcPaint.bottom - ps.rcPaint.top;

	int nPX = ps.rcPaint.left;
	int nPY = ps.rcPaint.top;

	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);

    CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	//int nWndWidth = rt.Width();
	//int nWndHeight = rt.Height();

	HDC hdc = dc.GetSafeHdc();

	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);

	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	Graphics graph(hdcMemory);

	if (hbmpMem)
	{
		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		//graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		ImageAttributes ImgAttr;

		if (m_pImgBG)
			DrawImageToDest(&graph, m_pImgBG, &rtPS, &rt, &ImgAttr);

		Image* pImgVolumeBG = m_pImgVolumeBG_B;
		Image* pImgVolume = m_pImgVolume_B;
		if ((m_nVolumeLimit - m_nVolume) <= 0)
		{
			pImgVolumeBG = m_pImgVolumeBG_R;
			pImgVolume = m_pImgVolume_R;
		}
		if (pImgVolumeBG)
			DrawImageToDest(&graph, pImgVolumeBG, &rtPS, &m_rtVolume, &ImgAttr);

		int nPct = 0;
		if (m_nVolumeLimit)
			nPct = (m_nVolume * 100) / m_nVolumeLimit;

		CRect rtVolumeReal = m_rtVolume;
		rtVolumeReal.right = rtVolumeReal.left + ((m_rtVolume.Width() * nPct) / 100);
		if (pImgVolume)
			DrawImageToDest(&graph, pImgVolume, &rtPS, &rtVolumeReal, &ImgAttr);

		CString strText = _T("");
		strText.Format(_T("%dGB / %dGB"), m_nVolume / (1024 * 1024), m_nVolumeLimit / (1024 * 1024));
		DrawTextToDest(&graph,
					   strText, &rtPS, &m_rtVolume,
					   m_rtVolume.Width() / 2, 4,
					   g_defaultFontFaceName, 11,
					   StringAlignmentCenter,
					   FontStyleRegular,
					   Color(255, 255, 255, 255), 3,
					   FALSE,
					   Color(255, 0, 0, 0), Color(255, 0, 0, 0));

		BitBlt(dc.GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

		::SelectObject(hdcMemory, hbmpOld);
		::DeleteObject(hbmpMem);
	}

	::DeleteDC(hdcMemory);
}

void CInfoVolumeWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_rtWnd.SetRect(0, 0, cx, cy);

	if (m_pImgVolumeBG_B)
	{
		int nImgWidth = m_pImgVolumeBG_B->GetWidth();
		int nImgHeight = m_pImgVolumeBG_B->GetHeight();

		int nSY = (m_rtWnd.Height() - nImgHeight) / 2;
		int nSX = nSY;		
		m_rtVolume.SetRect(nSX, nSY, cx - nSX, nSY + nImgHeight);
	}
}

void CInfoVolumeWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	CWnd::OnLButtonDown(nFlags, point);
}

void CInfoVolumeWnd::OnLButtonUp(UINT nFlags, CPoint point)
{
	CWnd::OnLButtonUp(nFlags, point);
}

void CInfoVolumeWnd::OnDestroy()
{
	if (m_pImgBG)
	{
		delete m_pImgBG;
		m_pImgBG = NULL;
	}

	if (m_pImgVolume_B)
	{
		delete m_pImgVolume_B;
		m_pImgVolume_B = NULL;
	}
	if (m_pImgVolumeBG_B)
	{
		delete m_pImgVolumeBG_B;
		m_pImgVolumeBG_B = NULL;
	}

	if (m_pImgVolume_R)
	{
		delete m_pImgVolume_R;
		m_pImgVolume_R = NULL;
	}
	if (m_pImgVolumeBG_R)
	{
		delete m_pImgVolumeBG_R;
		m_pImgVolumeBG_R = NULL;
	}

	CWnd::OnDestroy();
}
